import React from 'react';
import PropTypes from 'prop-types';
import {FormGroup} from 'reactstrap';
import Reaptcha from 'reaptcha';

const GoogleCaptcha = ({
                           siteKey,handleVerifyCallback, expiredCallback, error, style
                       }) => (
    <FormGroup>
        <Reaptcha
            onExpire={() => expiredCallback()}
            onVerify={e => handleVerifyCallback(e)}
            sitekey={siteKey}
        />
        <p style={style}>
            {error.message}
        </p>
    </FormGroup>
);

GoogleCaptcha.propTypes = {
    siteKey: PropTypes.string.isRequired,
    handleVerifyCallback: PropTypes.func.isRequired,
    expiredCallback: PropTypes.func.isRequired,
    error: PropTypes.shape(),
    style: PropTypes.shape()
};

GoogleCaptcha.defaultProps = {
    error: {
        status: 'invalid',
        message: ''
    },
    style: {
        width: '100%',
        paddingTop: 0.25,
        fontSize: '80%',
        color: '#dc3545'
    }
};

export default GoogleCaptcha;
