import Http from './http';
import {map, pullAll} from "lodash";

const sendNull = {
    result: null,
    size: null,
    total: null
};

function TableWrapper(token, query) {
    let parameters = query.endpoint
    if (token) { //forces token
        const searchOptions = map(query.search[0], (value, key) => {
            if (value) {
                return key + query.options[0] + value
            }
            return null
        })
        pullAll(searchOptions, [null])
        let result = ''
        let i = 0
        while (i <= searchOptions.length - 1) {
            result += searchOptions[i] + query.options[1]
            i++
        }
        return Http.get(parameters + result.slice(0, -1), token)
    }
    return sendNull
}

export default class OptionsService {
    static fetchOptions(token, e, query) {
        let parameters
        if (token) {
            parameters = query.search + '=' + e + query.options
            return Http.get(`${query.endpoint}${parameters}`, token);
        }
        return sendNull;
    }

    static fetchTable(token, query) {
        let state
        state = TableWrapper(token, query)
            .then(obj => {
                    if (obj.message) {
                        return {
                            error: ({anErrorOccurred: true, message: obj.message}),
                            loading: false,
                            size: 1,
                            total: 1,
                            pageCount: 1
                        }
                    } else {
                        return {
                            error: ({anErrorOccurred: false, message: null}),
                            loading: false,
                            result: obj.result,
                            size: obj.size,
                            total: obj.total,
                            pageCount: Math.ceil(obj.total / obj.size)
                        }
                    }
                }
            )
        return state
    }

}



